<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title>metaPascal Specification</title>
<style type="text/css">
a:link,A:link        { color: #000099; text-decoration:none; }
a:visited,A:visited  { color: #330066; text-decoration:none; }
a:active,A:active    { color: #009900; text-decoration:none; }
a:hover,A:hover      { color: #FF6600; text-decoration:none; }

body,p,ul,li {
  text-decoration:  none;
	font-size: 12px;
	font-family: Verdana, Arial, Helvetica, sans-serif; 
	font-weight: 400;
  color:            #000000;
}

pre {
   text-decoration:  none;
   font-family:      monaco,courier,courier-new;
   font-size:        9px;
   color:            #000000;
}

code {
   color:            #B22222;
}
</style>
</head>
<body>
  <h1>metaPascal Specification</h1>
  <p>For the purposes of generating common Pascal system interfaces for use in MW, GPC and FPC, we propose to define metaPascal, being essentially Pascal, with some specific requirements to provide easy automated parsing to generate interfaces for each compiler.</p>
  <p>For the most part, a metaPascal file is the same as a normal Pascal unit interface file as would be suitable to be compiled by any of the Mac Pascal compilers, and this document does not attempt to define all of Pascal, it only defines the specific restrictions or differences, as well as specifying specific usages where multiple different usages exist between the different compilers.</p>
  <p>metaPascal is designed primarily for interface files (although there may be small amounts of implementation code in some of the files) and is designed with the intention of making translation of existing C header files as easy as possible, as well as keeping common meanings as used by the C header files where appropriate.</p>
  <p>At the end of the day, the definition of metaPascal will come down to whatever the parsing script can input and correctly convert to equivalent interfaces for each of the compilers. This document attempts to define what those files should look like.</p>
  <h1>Specific Requirements</h1>
  <h2>File names</h2>
  <p>File names should match the C header name as closely as possible, and should end in &ldquo;.pas&rdquo;.  Since file names must not conflict with type names, file names may need to be changed, if so the preferred change is to add an &ldquo;s&rdquo; to the file name.  The unit name must exactly match the file name.  Case should be preserved in both the file name and unit name.</p>
  <h2>Line endings, white space, and comments</h2>
  <p>Files must have unix line endings (ie, a single linefeed). The carriage return character must not appear anywhere in the file.</p>
  <p>For the purposes of this document, <dfn>linear white space</dfn> means space or tab, <dfn>white space</dfn> means space, tab, or linefeed, and comments means any sequence of //, or {} comments with optional white space before, after or between them.  Do not use (**) comments (the () can confuse the script, and the C comments often include the construct (**xxx).yyy/</p>
  <p>{} comments may contain entire // comments, but not {} comments. // comments may not contain comments or comment start or ends.</p>
  <p>Care should be taken with the placement of line breaks and comments as the script is unlikely to be as forgiving in the placement of such things as a Pascal compiler. Specifically, only linear white space may be used around symbols like colon (:), equal (=), range (..), as well as commas (,) in parameters or record fields, and also parameters in general, except after the semicolons or before the trailing closing bracket. Do not put white space before semicolons (;). In general, do not needlessly add white space, line breaks or comments inside semantic units except in cases where it is typically done in the normal interfaces. If in any doubt, put comments on a previous line, or after the final semicolon (;).</p>
  <h2>File layout</h2>
  <p>Files must be strictly laid out as:</p>
  <pre>
comments
unit Name;
interface
uses unit1, unit2, unit3;
</pre>
  <p>There may be white space around the comments, but there may be no extraneous white space around the rest, except that arbitrary white space including at most one line break is allowed after <code>uses</code> and after a comma (,) in the uses clause. That is there must be a line break immediately proceeding <code>unit</code>, a single line break between the semicolon (;) and <code>interface</code>, a single line break between <code>interface</code> and <code>uses</code>.</p>
  <p>Interface comments (eg, {Modified for use with GNU Pascal...}) and compiler setup conditionals (eg, {$gnu-pascal}) will be placed immediately before the <code>unit</code>line. Conditional macros (eg, {$definec UNIVERSAL_INTERFACES_VERSION $0342}) will be placed immediately after the <code>interface</code> line. An alignment directive (eg, {$ALIGN MAC68K}) should be placed immediately after the uses clause (preceded by optional comments and white space).</p>
  <h2>Keywords must be lower case</h2>
  <p>All keywords (unit, interface, end, const, var, function, procedure, and so forth) must be in lower case.</p>
  <h2>Primary keywords must start the line</h2>
  <p>Primary keywords (uses, const, type, var, function, procedure) must start the line, preceded only by optional linear white space.</p>
  <h2>Use <code>univ</code>, <code>const var</code>, <code>FOUR_CHAR_CODE</code></h2>
  <p>The script will understand and process <code>univ</code> parameter types, <code>const var</code> parameters (equivalent to C&rsquo;s <code>const Type*</code> parameters, and the FOUR_CHAR_CODE macro.</p>
  <h2>Everything is assumed to be external</h2>
  <p><code>functions</code>, <code>procedures</code>, and <code>const x: y</code> are assumed to be external with a name matching the function/procedure/constant. The keyword <code>external</code> must not be used.</p>
  <h2>Use <code>const x: y;</code> as an external constant variable reference.</h2>
  <p>Do not use $J+ or other forms of external references. Always include, and start a line with, the <code>var</code> keyword. Do not include any comments or line breaks within the construct. Do not include <code>attribute( const )</code>.</p>
  <h2>Use <code>const x = CFSTR( 'string' );</code> for CFSTR constants.</h2>
  <p>Always include, and start a line with, the <code>const</code> keyword. Do not include any comments or line breaks within the construct. Use <code>const x: CFStringRef;</code> for externally defined CFStrings.</p>
  <h2>Use <code>attribute(ignorable);</code> if appropriate</h2>
  <p>If the function result is directly derived from the input parameters, in particular if the function result is merely the address of an input parameter, then you should include this token.  Do not include it simply because the return result might not be of interest, only if it is entirely redundant.  Do not include it just because you might not want to pay attention to the error result.</p>
  <p>The token must immediately follow (with only white space) the trailing ; of the function specification.</p>
  <h2>Use <code>AVAILABLE_MAC_OS_X_VERSION_10_3_AND_LATER;</code> if appropriate</h2>
  <p>Append <code>AVAILABLE_MAC_OS_X_VERSION_10_3_AND_LATER;</code> (or 10_2 or 10_4) to the end of constant references, procedures or functions as appropriate. It must immediately follow the trailing semicolon (;) with optional only white space between them.</p>
  <p>Use this where the constant references, procedures or functions are known to be available only in a certain version of the OS or later.  Typically use this if and only if the matching C header uses this token.</p>
  <h2>Use <code>{XX-ONLY-START}/{XX-ONLY-FINISH}</code> for compiler specific sections</h2>
  <p>If it is necessary to have different interfaces for MW, GPC and FPC, use non-nested, non-overlapping, sections of code surrounded by <code>{XX-ONLY-START}</code> and <code>{XX-ONLY-FINISH}</code> (eg <code>{MW-ONLY-START}</code>). For example, CFStringGlue and CFSTR definitions use this.  This should be a last resort.</p>
  <h2>Use <code>{$ALIGN MAC68K/POWER/DOUBLE/NATURAL}</code></h2>
  <p>Use this format to specify structure alignment. Note that it may not be possible to convert accurately for alignments other than MAC68K and POWER.</p>
  <h2>Use <code>{$propagate-units}</code></h2>
  <p>Use this immediately before the <code>unit</code> line to specify that the file contains only a uses clause and so should propagate the inclusion of other units.  The directive is kept for GPC and removed for MW and FPC.</p>
  <h2>Use conditionals <code>ifc/elsec/endc/definec</code> and <code>defined/not</code></h2>
  <p>Examples:</p>
  <ul>
    <li><code>{$definec USE_NON_APPLE_STANDARD_DATATYPES TRUE}</code></li>
    <li><code>{$ifc not TARGET_RT_BIG_ENDIAN}</code></li>
    <li><code>{$endc} {TARGET_RT_BIG_ENDIAN}</code></li>
    <li><code>{$ifc not defined qDebug}</code></li>
  </ul>
  <p>Conditionals must start the line (preceded by optional linear white space). Comments may follow conditionals. Do not use <code>undefined</code>.  <code>not</code> is supported for both <code>defined</code> and conditional negation.  Keep expressions as simple as possible and use them sparingly.</p>
  <h2>Implementation section</h2>
  <p>You can include an implementation section in the unit if necessary to implement some code (typically for C inline functions).  The interface function or procedure should have the keyword <code>implemented</code> before it, and then the keyword <code>implementation</code> should be included in the file on line by itself as normal, followed by the implementation code required.  No translation is applied to the implementation section, so you are on your own as far as making the code work with all three compilers.  See CFString.pas for an example.  Note there must be exactly one <code>implementation</code> and it must not be guarded {XX-ONLY-START} or conditionals.</p>
  <h2>Inline functions</h2>
  <p>Inline functions should generally be implemented as normal Pascal functions using the <code>implemented</code> keyword in the interface as described above.</p>
  <h2>gpcdefinec/mwgpcdefinec</h2>
  <p>Since GPC does not support unit exported macro definitions, you can use the code:</p>
<pre>
{$gpcdefinec macro(param) whatever}
</pre>
	<p>to define macros that will be added to the GPCMacros.inc file.  Since MW and GPC often define the same macros, you can define a macro with mwgpcdefinec that will be converted to an inline definec for MW, and a definec in GPCMacros.inc for GPC, and removed from FPC - an alternative solution, such as inline functions will be needed for FPC.</p>
  <p>Also, since the script does not know what ifc might be in affect at the point the macro is defined, but since that may need to be duplicated in GPCMacros.inc, you can specify a conditional guard for the GPCMacros.inc definition with:</p>
<pre>
{$gpcdefinec CONDITIONAL:macro(param) whatever}
</pre>
	<p>(CONDITIONAL may start with an ! for a negated conditional).  The CONDITIONAL part is removed from the MW definec.  See CFByteOrders.pas for examples.</p>
  <h2>TYPED_FUNCTION_POINTERS</h2>
  <p>TYPED_FUNCTION_POINTERS should be assumed to be always false, and is deprecated.  Any code conditionalized on it should be removed - function pointers are always typed (but see below for an issue on UPPs).</p>
  <h2>UnviersalProcPtrs</h2>
  <p>Currently GPC does not support return a procedural pointer, so the UPP types need to be defined as UniversalProcPtr.  Use exactly this format:</p>
<pre>
{GPC-ONLY-START}
	WindowDefUPP = UniversalProcPtr; // should be WindowDefProcPtr
{GPC-ONLY-ELSE}
	WindowDefUPP = WindowDefProcPtr;
{GPC-ONLY-FINISH}
</pre>
  <h2>OPAQUE_TOOLBOX_STRUCTS/Mac_68K</h2>
  <p>We have not formally decided to scrap OPAQUE_TOOLBOX_STRUCTS, but since it will never be on, you do not need to worry too much about the translation of records inside OPAQUE_TOOLBOX_STRUCTS.  Same for any sections that are Mac_68K or WIN32K specific.</p>
  <h2>Explicitly specifying linker name with aaa__NAMED__bbb</h2>
  <p>You can name a procedure, function or constant reference aaa__NAMED__bbb and if will be defined as aaa with linker name _bbb (for MW, it will be named bbb, since MW has no way to define a specific linker symbol).</p>
  <h2>Renamed functions</h2>
  <p>For functions that are renamed (eg MacFindWindow is really FindWindow), you can use the aaa__NAMED__bbb construct, for example:</p>
<pre>
function FindWindow( thePoint: Point; var window: WindowRef ): WindowPartCode;
AVAILABLE_MAC_OS_X_VERSION_10_0_AND_LATER;
{GPC-FPC-ONLY-START}
function MacFindWindow__NAMED__FindWindow( thePoint: Point; var window: WindowRef ): WindowPartCode;
AVAILABLE_MAC_OS_X_VERSION_10_0_AND_LATER;
{GPC-FPC-ONLY-FINISH}
</pre>
  <h1>Changes from the current GPC to metaPascal</h1>
  <ul>
    <li>Delete Interface comments, compiler setup conditionals, conditional macros.</li>
    <li>use <code>univ Ptr</code> instead of <code>UnivPtr</code> and <code>univ Handle</code> instead of <code>UnivHandle</code></li>
    <li>Remove <code>external name 'whatever';</code></li>
    <li><code>protected var</code> becomes <code>const var</code></li>
    <li><code>var x: y;</code> constant reference becomes <code>const x: y;</code></li>
    <li><code>{ x = CFSTR("string"); defined in GPCMacros.inc }</code> becomes <code>const x = CFSTR( 'string' );</code></li>
    <li><code>{$maximum-field-alignment...}</code> becomes <code>{$ALIGN MAC68K/POWER}</code></li>
  </ul>
  <h1>Translation Table</h1>
  <p>This section includes some mappings for C translation to metaPascal equivalent.</p>
  <dl>
  	<dt>non-array parameter form <code>const TypeID * parameterID</code></dt>
  	<dd><code>const var parameterID: TypeID</code></dd>
  	<dt>variable-size-array parameter form <code>const TypeID *
parameterID</code></dt>
	  <dd><code>{const} parameterID: {variable-size-array} TypeIDPtr</code> (you may need to define TypeIDPtr)</dd>
  	<dt>variable-size-array parameter form <code>const TypeID
parameterID[]</code></dt>
  	<dd><code>{const} parameterID: {variable-size-array} TypeIDPtr</code> (you may need to define TypeIDPtr)</dd>
  	<dt>fixed-size-array parameter form <code>const TypeID * parameterID</code></dt>
  	<dd><code>const var parameterID: ArrayTypeID</code> (you may need to define <code>ArrayTypeID = array[1..CArraySize] of TypeID;</code> declaration in the
type-declaration-part where TypeID is declared)</dd>
  	<dt>fixed-size-array parameter form <code>const TypeID parameterID[]</code></dt>
  	<dd><code>const var parameterID: ArrayTypeID</code> (you may need to define <code>ArrayTypeID = array[1..CArraySize] of TypeID;</code> declaration in the
type-declaration-part where TypeID is declared)</dd>
	 </dl>
  <h1>Getting Started</h1>
<ul>
<li>Checkout the subversion repository.</li>
<li>Run make test.</li>
<li>Ensure everything compiles cleanly.</li>
<li>Read metaPascal-Specification.html</li>
</ul>
  <h1>Translation Process</h1>
<ul>
<li>Update from subversion.</li>
<li>Choose a file or group of files to translate.</li>
<li>Add to the Todo.txt file your intention to do that set of files, check in the Todo.txt file, and email the list as well.  </li>
<li>Find the files in /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks</li>
<li>Make a new Temp directory (mkdir Temp).</li>
<li>Run the Scripts/Convert.pl script on the files to get a baseline:
<pre>
Scripts/Convert.pl /Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks/CoreServices.framework.../A/Headers/MacTypes.h NO Temp/
</pre></li>
<li>For an existing file, use BBEdit or the like to diff the new file with the existing file and update the existing file with any new stuff, being careful to preserve any existing differences unless you determine that the existing file is actually incorrect.  Add a line immediately above the "unit" line like:
<pre>
{       Pascal Translation Updated:  Peter N Lewis, &lt;peter@stairways.com.au&gt;, September 2005 }
</pre></li>
<li>For a new file, go over the file carefully, looking especially at types and parameters and any untranslated structures, and verify the translation.  Add a line immediately above the "unit" line like:
<pre>
{       Pascal Translation:  Peter N Lewis, &lt;peter@stairways.com.au&gt;, September 2005 }
</pre></li>
<li>Run &ldquo;make test&rdquo; and fix any problems.</li>
<li>Run Scripts/CompareFunctions.pl and check any changes are intentional.</li>
<li>When it compiles, make the Todo.txt entry as done, and check the whole lot in.</li>
<li>Do not check in new files unless they pass the "make test" or unless asking on the list first (it may be the easiest way to get Adriaan/Gale/me to help is to check it in even if it is not working).</li>
</ul>
</body>
</html>
